package pejb.rmi.client;
import java.rmi.Naming;
import java.rmi.registry.Registry;
import java.util.Vector;
import pejb.rmi.base.Workable;
import pejb.rmi.base.RmiUtil;

public class QueryClient {
	public static void main(String args[]) {
		String query = "Select name from sample";
		String rmiString = null, host = null;
		int port = Registry.REGISTRY_PORT;
		if(args.length < 1) {
			System.out.println("Usage: java QueryClient hostName [port]");
			System.exit(1);
		} else if( args.length == 1) {
			host = args[0];
		} else {
			host = args[0];
			try {
				port = Integer.parseInt(args[1]);
			} catch(NumberFormatException e) {
				System.err.println("Port Number is not a valid Number String. Setting port number default...");
			}
		}		
		rmiString = RmiUtil.getRmiString(Workable.NAME, host, port);
		try {
			Workable workable = (Workable)Naming.lookup(rmiString);
			QueryObject qryObj = new QueryObject("oracle.jdbc.driver.OracleDriver",
			"jdbc:oracle:thin:@211.47.153.166:1521:ORCL", "java", "nude");
			qryObj.setQuery(query);
			qryObj.setType(QueryObject.SELECT);
			System.out.println("Result for Query : " + query + "...");
			Vector result = (Vector)workable.doJob(qryObj);
			for(int i = 0; i < result.size(); i++) {
				System.out.println(result.elementAt(i));
			}			
		} catch (Exception e) {
			System.err.println("Couldn't successfully looked up remote object");
			e.printStackTrace();
		}
	}
}

