package pejb.rmi.client;
import java.util.Vector;
import pejb.rmi.base.AnyThing;
import java.io.Serializable;
import java.sql.*;
public class QueryObject implements AnyThing {
	private String driverName;
	private String dbURL;
	private String userName, password;
	private String query_str;
	private int query_type;
	public static final int SELECT = 1;
	public static final int UPDATE = 2;
	public QueryObject(String className, String url, String user, String passwd) {
		driverName = className;
		dbURL = url;
		userName = user;
		password = passwd;
	}
	public void setQuery (String str) {
		query_str = str;
	}
	public void setType(int type) {
		query_type = type;
	}
	public Serializable doThing() {
		Connection conn = null;
		Statement stmt = null;
		Vector v = null;
		try {
			Driver driver = (Driver)Class.forName(driverName).newInstance();
			//DriverManager.registerDriver(driver);
			System.out.println("Successfully loaded the driver");
			conn = DriverManager.getConnection(dbURL, userName, password);
			System.out.println("Successfully established connection to database");
			stmt = conn.createStatement();
			System.out.println("Successfully created statement ");
			v = execute(stmt);
		} catch(Exception e) {
			e.printStackTrace();
			v = new Vector();
			v.addElement("Couldn't Successfully executed the job you requested");
		} finally {
			try {
				if(stmt != null) stmt.close();
				if(conn != null) conn.close();
			} catch(Exception e) {}
		}
		return v;
	}
	private Vector execute(Statement stmt) throws SQLException {
		Vector v = new Vector();
		switch(query_type) {
			case SELECT:
				ResultSet rset = stmt.executeQuery(query_str);
				while(rset.next()) {
						v.addElement(rset.getString(1));
				}
				if(rset != null) rset.close();
			break;
			case UPDATE:
				int affectedRowCount = stmt.executeUpdate(query_str);
				v.addElement(new Integer(affectedRowCount));
			break;
			default:
				throw new SQLException("Invalid Query Type");
		}
		return v;
	}
}