package pejb.rmi.base;
import java.io.*;
import java.rmi.registry.Registry;
import java.rmi.MarshalledObject;
import java.rmi.Remote;
import java.util.Properties;
import java.rmi.RemoteException;
import java.rmi.activation.*;
public class RmiUtil {
	
	public static final String LOCALHOST = "localhost";
	private RmiUtil () {}
	public static String getRmiString(String name,String host, int port) {
		return "//" + host + ":" + port + "/" + name;
	}
	public static String getRmiString(String name, String host) {
		return getRmiString(name,host, Registry.REGISTRY_PORT);
	}
	public static String getRmiString(String name) {
		return getRmiString(name, LOCALHOST, Registry.REGISTRY_PORT);
	}
	public static String getRmiString(String name, int port) {
		return getRmiString(name, LOCALHOST, port);
	}
	public static Remote getRegisteredStub(String clsName, String url, String permit, MarshalledObject obj) 
	throws ActivationException , UnknownGroupException , RemoteException{
		Properties props = new Properties();
		props.put("java.security.policy", permit);
		ActivationGroupDesc.CommandEnvironment ace = null;
		ActivationSystem sys = ActivationGroup.getSystem();
		ActivationGroupID id = sys.registerGroup(new ActivationGroupDesc(props, ace));
		ActivationDesc desc = new ActivationDesc(id, clsName, url, obj);
		return Activatable.register(desc);
	}
	public static Remote getRegisteredStub(String clsName, String url, String permit) 
	throws ActivationException , UnknownGroupException, RemoteException {
		return getRegisteredStub(clsName, url, permit, null);
	}
		
}
		