package pejb.rmi.chat.server;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.util.*;
import pejb.rmi.base.*;
import pejb.rmi.chat.client.*;

public class ChatServer extends UnicastRemoteObject implements Server {
	private Vector allClients = new Vector(50, 50);
	public ChatServer() throws RemoteException {
		super();
	}
	
	public void addReceiver (Receiver client) throws RemoteException{
		allClients.addElement(client);
		System.out.println("Added a client ");
	}
	synchronized public void broadcast(String msg) throws RemoteException {
		int count = allClients.size();
		System.out.println("BroadCasting messages total " + count + " Receivers ..");
		Receiver client = null;
		for(int i = 0; i < count; i++) {
			client = (Receiver)allClients.elementAt(i);
			client.printMsg(msg);
		}
	}
	synchronized public void removeReceiver(Receiver client) throws RemoteException{
		allClients.removeElement(client);
		System.out.println("Removed a client current total: " + allClients.size());
	}
	public static void main(String [] args) {
		try {
			Server server = new ChatServer();
			Registry registry = LocateRegistry.createRegistry (2001);
			registry.rebind(Server.CHAT_SERVER, server);
			System.out.println("Remote Object[" + Server.CHAT_SERVER + "] bound ... on port " + 2001);
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
	}
}