package pejb.rmi.client;
import java.rmi.*;
import java.util.Properties;
import pejb.rmi.base.RmiUtil;
import pejb.rmi.base.Workable;

public class MailClient {
	public static void main(String [] args) {
		if(args.length < 2) {
			System.out.println("Usage: java MailClient rmiServerHost[ip] port");
			System.exit(1);
		}
		int port = 1099;
		try {
			port = Integer.parseInt(args[1]);
		} catch(Exception e) {
			System.out.println("Setting registry port to default");
		}
		Properties props = System.getProperties();
		props.put("java.security.policy", "permit");
		props.put("java.rmi.server.codebase", "http://211.47.153.175:8080/client.jar");
		System.setProperties(props);				
		System.setSecurityManager(new RMISecurityManager());
		String rmiStr = RmiUtil.getRmiString(Workable.NAME, args[0], port);
		
		Boolean isSent = Boolean.FALSE;
		try {
			Workable server = (Workable)Naming.lookup(rmiStr);
			System.out.println("Successfully lookup Workable server Remote object");
			MailWrapper mail = new MailWrapper();
			mail.setServer("dreamntech.com");
			mail.setTo("iboyang@dreamntech.com");
			mail.setFrom("iboyang@hanmail.net");
			mail.setSubject("Why Not Use RMI !!");
			mail.setMsgBody("RMI is pure java distributed object technology!! \n ູϼ^^");
			mail.setFooter("--- <God Still Loves You> --");
			isSent = (Boolean)server.doJob(mail);
		} catch(Exception e) {
			e.printStackTrace();
		}
		if(isSent.equals(Boolean.TRUE)) 
			System.out.println("Mail has been sent Successfully");
		else 
			System.out.println("Mail has not been sent to the recepient successfully");
	}
}
