package pejb.rmi.mail;

import sun.net.smtp.SmtpClient;
import java.io.PrintStream;
import java.io.IOException;
public class SimpleMailBean implements java.io.Serializable {
	private String from, to;
	private String server;
	private String subject;
	private String msg_body;
	private String footer;
	
	public SimpleMailBean() {
	}
	public boolean sendMail() {
		checkValid();
		try {
			SmtpClient mail_client = new SmtpClient(server);
			mail_client.from(from);
			mail_client.to(to);
			PrintStream ps = mail_client.startMessage();
			ps.println("TO: " + to);
			ps.println("Subject: " + euc2asc(subject) +"\n");
			ps.println(euc2asc(msg_body));
			ps.println("\n\n" + euc2asc(footer));
			mail_client.closeServer();
			return true;
		} catch(IOException e) {
			e.printStackTrace();
			return false;
		}
	}
	public void setFrom(String from) {
		this.from = from;
	}
	public void setTo(String to) {
		this.to = to;
	}
	public void setServer(String server) {
		this.server = server;
	}
	public void setSubject(String subject) {
		this.subject = subject;
	}
	public void setMsgBody(String body) {
		this.msg_body = body;
	}
	public void setFooter(String footer) {
		this.footer = footer;
	}	
	public String getFrom() { return from; }
	public String getTo() { return to; }
	public String getServer() { return server; }
	public String getSubject() { return subject; }
	public String getContent() { return msg_body; }
	public String getFooter() { return footer; }
	public String euc2asc(String euc) {
		if( euc == null) return "";
		try {
			return new String (euc.getBytes("euc-kr"), "8859_1");
		} catch(Exception e) {
			return "failed to encode properly : \n" + euc;
		}
	}
	private void checkValid() {
		if(to == null || to.indexOf("@") == -1) 
			to = "anonymous@somewhere.else.com";
		if(from == null || from.indexOf("@") == -1) 
			from = "anonymouse@somewhere.else.com";
		if(subject == null || subject.length() == 0) 
			subject = "[No Subject]";
		if(footer == null || footer.length() == 0) 
			footer = "He has come and with us now  !!";
	}
		
		
}
	