//HelloClient.java
import javax.naming.InitialContext;
import javax.naming.Context;
import javax.rmi.PortableRemoteObject;
import java.util.Properties;

import java.io.*;
public class HelloClient {
	public static void main(String [] args) {
		if(args.length < 1) {
			System.out.println("Usage: java -classpath ... HelloClient YourName ");
			System.exit(1);
		}
		try {
			
			//Context init_ctx = new InitialContext(); //J2EE SDK  
			Context init_ctx = getInitialContextForWeblogic(); //  
			Object obj = init_ctx.lookup("Hello");
			HelloHome home = 
			(HelloHome)PortableRemoteObject.narrow(obj ,HelloHome.class);
			
			Hello hello = home.create();
			Hello hello1 = home.create();
			System.out.println("hello == hello1 : " + (hello == hello1));
			System.out.println("hello.isIdentical(hello1) : " + hello.isIdentical(hello1));
			String ret_msg = hello.sayHello(args[0]);
			System.out.println(ret_msg);
			
			// HomeHandle ´.
			javax.ejb.HomeHandle home_handle = home.getHomeHandle();
			//Handle ´.
			javax.ejb.Handle handle = hello.getHandle();
			
			//Handle ȭ Ͽ serialized_handle01.ser Ͽ Ѵ.
			FileOutputStream fos = new FileOutputStream("serialized_handle01.ser");
			ObjectOutputStream objOut = new ObjectOutputStream(fos);
			objOut.writeObject(handle);
			System.out.println("Handle serialized successfully");
			fos.close();
			objOut.close();
			
			//HomeHandle ȭ Ͽ serialized_home_handle01.ser Ͽ Ѵ.
			FileOutputStream home_fos = new FileOutputStream("serialized_home_handle01.ser");
			ObjectOutputStream home_objOut = new ObjectOutputStream(home_fos);
			home_objOut.writeObject(home_handle);
			System.out.println("HomeHandle serialized successfully");
			home_fos.close();
			home_objOut.close();
			
			
		} catch(Exception e) {
			e.printStackTrace();
		} 
	} // end of main
	static InitialContext	getInitialContextForWeblogic() throws javax.naming.NamingException {
		Properties props = new Properties();
		props.put(Context.INITIAL_CONTEXT_FACTORY, "weblogic.jndi.WLInitialContextFactory");
		props.put(Context.PROVIDER_URL, "t3://localhost:7001");
		return new javax.naming.InitialContext(props);
	}
}
