package pejb.ejb.entity.board;
import javax.ejb.*;
import javax.naming.*;
import javax.sql.DataSource;
import java.util.Enumeration;
import java.util.Vector;
import java.sql.*;

public class BoardBean extends pejb.ejb.base.EntityAdapter{
//////// Persistent Fields ////////	
	public int recno;
	public int ref;
	public int step;
	public int depth;
	public int hitCnt;
	public int replyCnt;
	public String userId;
	public String userName;
	public String passwd;
	public String email;
	public String subject;
	public String contents;
	public Date registeredDate; 
	
	private String jndi_database = "java:comp/env/jdbc/BoardDB";

	public BoardPK ejbCreate(int recno, int ref, String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt) throws CreateException {
		return ejbCreate(recno, ref, 0, 0, userId, 
		userName, email, subject, contents, passwd, regDt);
	}
	public BoardPK ejbCreate(int recno, int ref, int step, int depth,
	String userId, String userName, String email, String subject, 
	String contents, String passwd, Date regDt ) throws CreateException {
		print("ejbCreate... called");
		int affectedRowCount = 0;
		this.recno = recno;
		this.ref = ref;
		this.step = step;
		this.depth = depth;
		this.userId = userId;
		this.userName = userName;
		this.email = email;
		this.subject = subject;
		this.contents = contents;
		this.passwd = passwd;
		this.registeredDate = regDt;
		try {
			affectedRowCount = insertIntoTable(recno, ref, step, depth, userId, 
					userName, email, subject, contents, passwd, regDt );
		} catch(SQLException e) {
			print("Couldn't create a entity bean...");
			throw new CreateException(e.getMessage());	
		}
		if(affectedRowCount != 1) 
		throw new CreateException("Couldn't create Entity Bean: Failed to insert a record");
		BoardPK pk = new BoardPK(recno);
		return pk;
	}
	
	public void ejbPostCreate(int recno, int ref, String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt) throws CreateException {
		print("ejbPostCreate called");
	}
	public void ejbPostCreate(int recno, int ref, int step, int depth , String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt) 
	throws CreateException {
		print("ejbPostCreate called");
	}

	public  BoardPK ejbFindByPrimaryKey(BoardPK pk) throws FinderException{
		boolean exists =false;
		try {
			exists = selectFromTableByPrimaryKey(pk);
		} catch(SQLException e) {
			throw new EJBException(e.getMessage());	
		}
			
		if(exists) {
			return pk;
		} else {
			throw new ObjectNotFoundException("EntityBean with " + pk + " Not Found ");
		}
		
	}
	
	////////// User-Defined Finder Method //////////////

	public Enumeration ejbFindByRef(int ref) throws FinderException{
		try {
			Enumeration enum = selectFromTableByRef(ref);
			if(!enum.hasMoreElements()) 
				throw new FinderException(
				"Couldn't Find any EntityBean with this REF: " 
				+ ref);
			return enum;
		} catch(SQLException e) {
			throw new EJBException(e.getMessage());	
		}
	}
	
	///////////  ̽  ޼ҵ....	////////////////
	public void setRef(int ref) { this.ref = ref; }
	public void setStep(int step) { this.step = step; }
	public void setDepth(int depth) { this.depth = depth; }
	public void setReplyCnt(int replyCnt) { this.replyCnt = replyCnt; }
	public void setHitCnt(int hitCnt) { this.hitCnt = hitCnt; }
	
	public void setUserId(String userId) { this.userId = userId; }
	public void setUserName(String userName) { this.userName = userName; }
	public void setEmail(String email) { this.email = email; }
	public void setSubject(String subject) { this.subject = subject; }
	public void setContents(String contents) { this.contents = contents; }
	public void setPasswd(String passwd) { this.passwd = passwd; }
	public void setRegisteredDate(Date regDt) { this.registeredDate = regDt; }

	public int getRef() { return ref; }
	public int getStep() { return step; }
	public int getDepth() {return depth; }
	public int getReplyCnt() { return replyCnt; }
	public int getHitCnt() { return hitCnt; }
	
	public String getUserId() { return userId; }
	public String getUserName() { return userName; }
	public String getEmail() { return email; }
	public String getPasswd() { return passwd; }
	public String getContents() { return contents; }
	public String getSubject() { return subject; }
	public Date getRegisteredDate() { return registeredDate; }
	
////////// EntityBean ̽  ޼ҵ ̵ ///////
	public void setEntityContext(EntityContext ctx ) {
		debug = true;
		ejb_name = getClass().getName();
		super.setEntityContext(ctx);
	}
	
	public void ejbLoad() {
		super.ejbLoad();
		Connection conn = null;
		String query = "SELECT * FROM BOARD WHERE RECNO = ?";
		BoardPK pk = (BoardPK)ctx.getPrimaryKey();
		this.recno = pk.recno;
		try {
			conn = this.getConnection();
			if(conn == null) 
				throw new EJBException("Couln't obtain a valid database connection");
			PreparedStatement stmt = conn.prepareStatement(query);
			stmt.setInt(1, recno);
			ResultSet rset = stmt.executeQuery();
			while(rset.next()) {
				this.contents = rset.getString("CONTENTS");
				this.ref = rset.getInt("REF");
				this.step = rset.getInt("STEP");
				this.depth = rset.getInt("DEPTH");
				this.hitCnt = rset.getInt("HITCNT");
				this.replyCnt = rset.getInt("REPLYCNT");
				this.userId = rset.getString("USERID");
				this.userName = rset.getString("USERNAME");
				this.passwd = rset.getString("PASSWD");
				this.email = rset.getString("EMAIL");
				this.subject = rset.getString("SUBJECT");
				this.registeredDate = rset.getDate("REGDT"); 
			}
			stmt.close();
		} catch(SQLException e) {
			throw new EJBException (e.getMessage());
		} finally {
			try {
				if(conn != null) conn.close();
			} catch(Exception e) {e.printStackTrace(); }
		}
	}
	public void ejbStore() {
		super.ejbStore();
		Connection conn = null;
		String query = "UPDATE BOARD SET REF=?, STEP=?, DEPTH=?, HITCNT=?, REPLYCNT=?,"
		+ " USERID=?, USERNAME=?,   PASSWD=?, EMAIL=? , SUBJECT=?, CONTENTS=?, REGDT=? WHERE RECNO=?";

		try {
			conn = this.getConnection();
			if(conn == null) 
				throw new EJBException("Couln't obtain a valid database connection");
			PreparedStatement stmt = conn.prepareStatement(query);
			stmt.setInt(1, ref);
			stmt.setInt(2, step);
			stmt.setInt(3, depth);
			stmt.setInt(4, hitCnt);
			stmt.setInt(5, replyCnt);
			stmt.setString(6, userId);
			stmt.setString(7, userName);
			stmt.setString(8, passwd);
			stmt.setString(9, email);
			stmt.setString(10, subject);
			stmt.setString(11, contents);
			stmt.setDate(12, registeredDate);
			stmt.setInt(13, recno);
			int affectedRowCount = stmt.executeUpdate();
			if( affectedRowCount != 1) 
				throw new NoSuchEntityException("Entity with RECNO: " + recno + " not exits!!" );
			stmt.close();

		} catch(SQLException e) {
			throw new EJBException (e.getMessage());
		}finally {
			try {
				if(conn != null) conn.close();
			} catch(Exception e) {e.printStackTrace();}
		}
	}
	public void ejbRemove() {
		try {
			int affectedRowCount = deleteFromTable();
			if(affectedRowCount != 1) throw new NoSuchEntityException("The record with Primary Key RECNO:" + this.recno
			+ " was Already Deleted from Database Table BOARD");
			print("ejbRemoved: ejbRemove() called");
		} catch(SQLException e) {
			print("faile to remove Entity Bean");
			throw new EJBException (e.getMessage());
		}
	}
	
/////////// Database Query Utilities ////////////////////////		
	private void insertIntoTable(int recno, int ref, String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt ) throws SQLException {
		insertIntoTable(
		recno, ref, 0, 0, userId, 
		userName, email, subject, 
		contents,passwd, regDt);
				
	}
	private int insertIntoTable(int recno, int ref, int step, int depth,
	String userId, 	String userName, String email, String subject, 
	String contents, String passwd, Date regDt) throws SQLException {
		String query = "INSERT INTO  BOARD " + 
		"(RECNO, REF, STEP, DEPTH, USERID, USERNAME, " + 
		" EMAIL, SUBJECT, CONTENTS, PASSWD, REGDT) "
		+ " values(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
		Connection conn = this.getConnection();
		int affectedRowCount = 0;
		if(conn == null) 
			throw new EJBException("Couln't obtain a valid database connection");
		try {
			PreparedStatement stmt = conn.prepareStatement(query);
			stmt.setInt(1, recno);
			stmt.setInt(2, ref);
			stmt.setInt(3, step);
			stmt.setInt(4, depth);
			stmt.setString(5, userId);
			stmt.setString(6, userName);
			stmt.setString(7, email);
			stmt.setString(8, subject);
			stmt.setString(9, contents);
			stmt.setString(10, passwd);
			stmt.setDate(11, regDt);
			affectedRowCount = stmt.executeUpdate();
			stmt.close();

		} finally {
			conn.close();
		}
		return affectedRowCount;
	}
	private int deleteFromTable () throws SQLException {
		String query = "DELETE FROM BOARD WHERE RECNO=?";
		Connection conn = this.getConnection();
		int affectedRowCount = 0;
		if(conn == null) throw new EJBException("Couln't obtain a valid database connection");
		try {
			PreparedStatement stmt = conn.prepareStatement(query);
			stmt.setInt(1, ((BoardPK)ctx.getPrimaryKey()).recno);
			affectedRowCount = stmt.executeUpdate();
			stmt.close();
		} finally {
			conn.close();
		}
		return affectedRowCount;
	}
			
	private boolean selectFromTableByPrimaryKey(BoardPK pk) throws SQLException {
		Connection conn = this.getConnection();
		if(conn == null) throw new EJBException("Couln't obtain a valid database connection");
		String query = "SELECT RECNO FROM BOARD WHERE RECNO=?";
		try {
			PreparedStatement stmt = conn.prepareStatement(query);
			stmt.setInt(1, pk.recno);
			ResultSet rset = stmt.executeQuery(); 
			boolean result = rset.next();
			stmt.close();
			return result;
		} finally {
			conn.close();
		}
	}	

	private Enumeration selectFromTableByRef(int ref) throws SQLException {
		Connection conn = this.getConnection();
		if(conn == null) throw new EJBException("Couln't obtain a valid database connection");
		String query = "SELECT RECNO FROM BOARD WHERE REF=?";
		try {
			PreparedStatement stmt = conn.prepareStatement(query);
			stmt.setInt(1, ref);
			ResultSet rset = stmt.executeQuery(); 
			Vector v = new Vector();
			while(rset.next()) {
				v.addElement(new BoardPK(rset.getInt(1)));
			}
			stmt.close();
			return v.elements();
		} finally {
			conn.close();
		}
	}


	private Connection getConnection(){
		Connection conn = null;
		try {
			InitialContext context = new InitialContext();
			DataSource datasource =(DataSource) context.lookup(jndi_database);
			 conn = datasource.getConnection();
			 print("Got Valid Database connection From pool");
		} catch(NamingException e) {
			print("Couldn't Create a valid jndi InitialContext for lookup DateSource ");
		} catch(SQLException e) {
			print("Couldn't obtain a valid connection from database " +
			e.getMessage());
		} finally {
			return conn;
		}
	}
}

