import javax.ejb.*;
import javax.naming.*;
import java.util.*;
import java.sql.Date;
import java.rmi.RemoteException;
import javax.rmi.PortableRemoteObject;
import pejb.ejb.entity.board.Board;
import pejb.ejb.entity.board.BoardPK;
import pejb.ejb.entity.board.BoardHome;

public class BoardClient {
	public static void main(String [] args) {
		Properties props = new Properties();
		props.put(Context.INITIAL_CONTEXT_FACTORY, 
		"weblogic.jndi.WLInitialContextFactory");
		props.put(Context.PROVIDER_URL, "t3://localhost:7001");
		
		try {
			//InitialContext ctx = new InitialContext(); J2EE SDK  
			InitialContext ctx = new InitialContext(props);
			Object obj = ctx.lookup("Board");
			BoardHome home = 
			(BoardHome) PortableRemoteObject.narrow(obj, BoardHome.class);
			println("Looked up an EJBHome Object ");
			Board ejb = home.create(1,1, "iboyang", "Yang Hooe Suk", 
			"iboyang@dreamntehc.com", "Posting Number " + 1, 
			"contents Number " + 1,	"javalove", 
			new Date(System.currentTimeMillis())); 
			createSampleBoardData(home);
			BoardPK pk1  = new BoardPK(2);
			BoardPK pk2 = new BoardPK(2);
			BoardPK pk3 = new BoardPK(3);
			
			Board ejb_1 = home.findByPrimaryKey(pk1);
			println("Found an entity EJBObject with Primary Key pk1: " + pk1);
			Board ejb_2 = home.findByPrimaryKey(pk2);
			println("Found an entity EJBObject with Primary Key pk2: " + pk2);
			Board ejb_3 = home.findByPrimaryKey(pk3);
			println("Found an entity EJBObject with Primary Key pk3: " + pk3);
			Enumeration enum = home.findByRef(5);
			while(enum.hasMoreElements()) {
				Object elem = enum.nextElement();
				Board ejb_obj = (Board)PortableRemoteObject.narrow(elem, Board.class);
				println("Found an entity which maps to ref " + 5);
				println("ejb_obj.getUserName() : " + ejb_obj.getUserName());
			}
			ejb_1.setUserName("ȸ");
			ejb_2.setUserName("");
			ejb_3.setUserName("");
					
			println("ejb.getUserName(): " + ejb.getUserName());
			println("ejb_1.getUserName(): " + ejb_1.getUserName());
			println("ejb_2.getUserName(): " + ejb_2.getUserName());
			ejb_1.setUserName("ȸ");
			println(ejb_1.getUserName());
			println("ejb_1.isIdentical(ejb_2) == " + ejb_1.isIdentical(ejb_2));
			
			
			ejb_1.remove();
			println("Removed ejb_1");
			home.remove(pk3);
			println("Removed board record with " + pk3 );
		
		} catch(NamingException e) {
			e.printStackTrace();
			System.exit(1);
		} catch(CreateException e) {
			e.printStackTrace();
		} catch(FinderException e) {
			e.printStackTrace();
		} catch(RemoveException e) {
			e.printStackTrace();
		} catch(RemoteException e) {
			e.printStackTrace();
		}
	}
	static void createSampleBoardData(BoardHome home) 
	throws CreateException, java.rmi.RemoteException {
		for(int i = 2; i <= 5; i++) {
			home.create(i,i, "iboyang", "Yang Hooe Suk", 
			"iboyang@dreamntehc.com", "Posting Number " + i, 
			"contents Number " + i,	"javalove", 
			new Date(System.currentTimeMillis())); 
			println("Created entity bean with primary key field " + i);
		}
	}
	static void println(String str) { 
		System.out.println(str);
	}
}
