import javax.ejb.*;
import javax.naming.*;
import java.util.*;
import java.sql.Date;
import java.rmi.RemoteException;
import javax.rmi.PortableRemoteObject;
import pejb.ejb.session.board.*;
import pejb.ejb.base.*;
import pejb.beans.board.*;
import pejb.ejb.entity.board.*;

public class SearchRecClient {
	public static void main(String [] args) {
		pejb.ejb.base.EJBUtil util = new pejb.ejb.base.EJBUtil();
		
		try {
			BoardHome board_home = (BoardHome)util.lookup("CMPBoard", BoardHome.class, EJBUtil.J2EESDK);
			createSampleData(board_home);
			Board ejb1 = board_home.findByPrimaryKey(new BoardPK(1));
			
			System.out.println(ejb1.getPrimaryKey());
			System.out.println(ejb1.getUserName());
			SearchRecHome home = (SearchRecHome)util.lookup("SearchRec", SearchRecHome.class, EJBUtil.J2EESDK);
			SearchRec ejb = home.create();
			Vector recs = ejb.getAllBoard("","", 2);
			int count = recs.size();
			for(int i = 0; i < count; i++) 	{
				BoardRec rec = (BoardRec) recs.elementAt(i);
				System.out.println(rec.getRef());
			}
			//ejb.increaseHitCnt(99);
		} catch(Exception e) { e.printStackTrace(); }
	}
	public static void createSampleData(BoardHome home ) throws Exception {
		for(int i = 0; i < 100; i++) {
			home.create(i,i, "iboyang", "Yang Hooe Suk", 
			"iboyang@dreamntehc.com", "Posting Number " + i, 
			"contents Number " + i,	"javalove", 
			new Date(System.currentTimeMillis())); 
		}
	}
}
