package pejb.ejb.entity.board;
import javax.ejb.*;
import javax.naming.*;
import javax.sql.DataSource;
import java.util.Enumeration;
import java.util.Vector;
import java.util.StringTokenizer;
import java.sql.*;
import pejb.ejb.base.EJBUtil;

public class BoardBean extends pejb.ejb.base.EntityAdapter{
//////// Persistent Fields ////////	
	public int recno;
	public int ref;
	public int step;
	public int depth;
	public int hitCnt;
	public int replyCnt;
	public String userId;
	public String userName;
	public String passwd;
	public String email;
	public String subject;
	public String contents;
	public Date registeredDate; 
	
	private String jndi_database = "java:comp/env/jdbc/BoardDB";
	private EJBUtil util;
	public BoardPK ejbCreate(int recno, int ref, String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt) throws CreateException {
		return ejbCreate(recno, ref, 0, 0, userId, 
		userName, email, subject, contents, passwd, regDt);
	}
	public BoardPK ejbCreate(int recno, int ref, int step, int depth,
	String userId, String userName, String email, String subject, 
	String contents, String passwd, Date regDt ) throws CreateException {
		print("ejbCreate... called");
		int affectedRowCount = 0;
		this.recno = recno;
		this.ref = ref;
		this.step = step;
		this.depth = depth;
		this.userId = userId;
		this.userName = userName;
		this.email = email;
		this.subject = subject;
		this.contents = contents;
		this.passwd = passwd;
		this.registeredDate = regDt;
		try {
			affectedRowCount = insertIntoTable(recno, ref, step, depth, userId, 
					userName, email, subject, contents, passwd, regDt );
		} catch(SQLException e) {
			print("Couldn't create a entity bean...");
			throw new CreateException(e.getMessage());	
		}
		if(affectedRowCount != 1) 
		throw new CreateException("Couldn't create Entity Bean: Failed to insert a record");
		BoardPK pk = new BoardPK(recno);
		return pk;
	}
	
	public void ejbPostCreate(int recno, int ref, String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt) throws CreateException {
		print("ejbPostCreate called");
	}
	public void ejbPostCreate(int recno, int ref, int step, int depth , String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt) 
	throws CreateException {
		print("ejbPostCreate called");
	}

	public  BoardPK ejbFindByPrimaryKey(BoardPK pk) throws FinderException{
		boolean exists =false;
		try {
			exists = selectFromTableByPrimaryKey(pk);
		} catch(SQLException e) {
			throw new EJBException(e.getMessage());	
		}
			
		if(exists) {
			return pk;
		} else {
			throw new ObjectNotFoundException("EntityBean with " + pk + " Not Found ");
		}
	}
	
	////////// User-Defined Finder Method //////////////
	public Enumeration ejbFindByRef(int ref) throws FinderException{
		try {
			Enumeration enum = selectFromTableByRef(ref);
			if(!enum.hasMoreElements()) 
				throw new FinderException(
				"Couldn't Find any EntityBean with this REF: " 
				+ ref);
			return enum;
		} catch(SQLException e) {
			throw new EJBException(e.getMessage());	
		}
	}
	
	///////////  ̽  ޼ҵ....	////////////////
	public void setRef(int ref) { this.ref = ref; }
	public void setStep(int step) { this.step = step; }
	public void setDepth(int depth) { this.depth = depth; }
	public void setReplyCnt(int replyCnt) { this.replyCnt = replyCnt; }
	public void setHitCnt(int hitCnt) { this.hitCnt = hitCnt; }
	
	public void setUserId(String userId) { this.userId = userId; }
	public void setUserName(String userName) { this.userName = userName; }
	public void setEmail(String email) { this.email = email; }
	public void setSubject(String subject) { this.subject = subject; }
	public void setContents(String contents) { this.contents = contents; }
	public void setPasswd(String passwd) { this.passwd = passwd; }
	public void setRegisteredDate(Date regDt) { this.registeredDate = regDt; }

	public int getRef() { return ref; }
	public int getStep() { return step; }
	public int getDepth() {return depth; }
	public int getReplyCnt() { return replyCnt; }
	public int getHitCnt() { return hitCnt; }
	
	public String getUserId() { return userId; }
	public String getUserName() { return userName; }
	public String getEmail() { return email; }
	public String getPasswd() { return passwd; }
	public String getContents() { return contents; }
	public String getSubject() { return subject; }
	public Date getRegisteredDate() { return registeredDate; }
	
////////// EntityBean ̽  ޼ҵ ̵ ///////
	public void setEntityContext(EntityContext ctx ) {
		debug = true;
		ejb_name = getClass().getName();
		util = new EJBUtil();
		super.setEntityContext(ctx);
	}
	
	public void ejbLoad() {
		super.ejbLoad();
		Connection conn = null;
		Statement stmt = null;
		ResultSet rset = null;
		BoardPK pk = (BoardPK)ctx.getPrimaryKey();
		this.recno = pk.recno;
		String query = "SELECT * FROM BOARD WHERE RECNO = " + recno;
		try {
			conn = this.getConnection();
			if(conn == null) 
				throw new EJBException("Couldn't obtain a valid database connection");
			stmt = conn.createStatement();
			rset = stmt.executeQuery(query);
			while(rset.next()) {
				this.contents = rset.getString("CONTENTS");
				this.ref = rset.getInt("REF");
				this.step = rset.getInt("STEP");
				this.depth = rset.getInt("DEPTH");
				this.hitCnt = rset.getInt("HITCNT");
				this.replyCnt = rset.getInt("REPLYCNT");
				this.userId = rset.getString("USERID");
				this.userName = rset.getString("USERNAME");
				this.passwd = rset.getString("PASSWD");
				this.email = rset.getString("EMAIL");
				this.subject = rset.getString("SUBJECT");
				this.registeredDate = rset.getDate("REGDT"); 
			}
		} catch(SQLException e) {
			throw new EJBException (e.getMessage());
		} finally {
			close(rset, stmt, conn);
		}
	}
	public void ejbStore() {
		super.ejbStore();
		StringBuffer sb =new StringBuffer();
		sb.append("UPDATE  BOARD SET REF=" + ref + ",");
		sb.append("STEP=" + step + ",DEPTH=" + depth + ",");
		sb.append("HITCNT=" + hitCnt + ", REPLYCNT=" + replyCnt + ",");
		sb.append("USERID=" + makeSQL(userId) + ",USERNAME=" + makeSQL(userName ) + ",");
		sb.append("PASSWD=" +  makeSQL(passwd) + ",EMAIL=" + makeSQL(email) + ",");
		sb.append("SUBJECT=" + makeSQL(subject) + ",CONTENTS=" + makeSQL(contents)  + ",");
		sb.append("REGDT= to_date(" + makeSQL(registeredDate.toString())+", 'yyyy-mm-dd') ");
		sb.append("WHERE RECNO=" + recno);

		Connection conn = this.getConnection();
		Statement stmt = null;
		try {
			conn = this.getConnection();
			if(conn == null) 
				throw new EJBException("Couln't obtain a valid database connection");
			stmt = conn.createStatement();
			int affectedRowCount = stmt.executeUpdate(sb.toString());
			if( affectedRowCount != 1) 
				throw new NoSuchEntityException("Entity with RECNO: " + recno + " not exits!!" );
		} catch(SQLException e) {
			e.printStackTrace();
			throw new EJBException (e.getMessage());
			
		}finally {
			close(null, stmt, conn);
		}
	}
	public void ejbRemove() {
		try {
			int affectedRowCount = deleteFromTable();
			if(affectedRowCount != 1) 
			throw new NoSuchEntityException("The record with Primary Key RECNO:" + 
			this.recno + " was Already Deleted from Database Table BOARD");
			print("ejbRemoved: ejbRemove() called");
		} catch(SQLException e) {
			print("faile to remove Entity Bean");
			throw new EJBException (e.getMessage());
		}
	}
	
/////////// Database Query Utilities ////////////////////////		
	private void insertIntoTable(int recno, int ref, String userId, 
	String userName, String email, String subject, String contents, 
	String passwd, Date regDt ) throws SQLException {
		insertIntoTable(
		recno, ref, 0, 0, userId, 
		userName, email, subject, 
		contents,passwd, regDt);
				
	}
	private int insertIntoTable(int recno, int ref, int step, int depth,
	String userId, 	String userName, String email, String subject, 
	String contents, String passwd, Date regDt) throws SQLException {
		StringBuffer sb =new StringBuffer();
		sb.append("INSERT INTO  BOARD ");
		sb.append("(RECNO, REF, STEP, DEPTH, USERID, USERNAME, ");
		sb.append(" EMAIL, SUBJECT, CONTENTS, PASSWD, REGDT) ");
		sb.append(" values(" + recno + "," + ref + "," + step ); 
		sb.append("," + depth + "," + makeSQL(userId) + "," ); 
		sb.append(makeSQL(userName) + "," + makeSQL(email) + ",");
		sb.append(makeSQL(subject) + "," + makeSQL(contents) + ",");
		sb.append(makeSQL(passwd) + ", to_date(" + makeSQL(regDt.toString())
		 + ", 'yyyy-mm-dd'))");
		Connection conn = this.getConnection();
		Statement stmt = null;
		int affectedRowCount = 0;
		if(conn == null) 
			throw new EJBException("Couln't obtain a valid database connection");
		try {
			stmt = conn.createStatement();
			affectedRowCount = stmt.executeUpdate(sb.toString());

		} finally {
			close(null, stmt, conn);
		}
		return affectedRowCount;
	}
	private int deleteFromTable () throws SQLException {
		String query = "DELETE FROM BOARD WHERE RECNO=?";
		Connection conn = this.getConnection();
		PreparedStatement stmt = null;
		int affectedRowCount = 0;
		if(conn == null) 
			throw new EJBException("Couln't obtain a valid database connection");
		try {
			stmt = conn.prepareStatement(query);
			stmt.setInt(1, ((BoardPK)ctx.getPrimaryKey()).recno);
			affectedRowCount = stmt.executeUpdate();
		} finally {
			close(null, stmt, conn);
		}
		return affectedRowCount;
	}
			
	private boolean selectFromTableByPrimaryKey(BoardPK pk) throws SQLException {
		Connection conn = this.getConnection();
		if(conn == null) 
			throw new EJBException("Couln't obtain a valid database connection");
		String query = "SELECT RECNO FROM BOARD WHERE RECNO=?";
		ResultSet rset = null;
		PreparedStatement stmt = null;
		try {
			stmt = conn.prepareStatement(query);
			stmt.setInt(1, pk.recno);
			rset = stmt.executeQuery(); 
			boolean result = rset.next();
			return result;
		} finally {
			close(rset, stmt, conn);
		}
	}	

	private Enumeration selectFromTableByRef(int ref) throws SQLException {
		Connection conn = this.getConnection();
		if(conn == null) throw new EJBException("Couln't obtain a valid database connection");
		String query = "SELECT RECNO FROM BOARD WHERE REF=?";
		ResultSet rset = null;
		PreparedStatement stmt = null;
		try {
			stmt = conn.prepareStatement(query);
			stmt.setInt(1, ref);
			rset = stmt.executeQuery(); 
			Vector v = new Vector();
			while(rset.next()) {
				v.addElement(new BoardPK(rset.getInt(1)));
			}
			return v.elements();
		} finally {
			close(rset, stmt, conn);
		}
	}
	private void close(ResultSet rset, Statement stmt, Connection conn) {
		try {
			if(rset != null) rset.close();
			if(stmt != null) stmt.close();
			if(conn != null) {
				conn.close();
				conn = null;
			}
		} catch(Exception e) { e.printStackTrace(); }
	}
	private Connection getConnection(){
		return util.getConnection(jndi_database);	
	}
	private String makeSQL(String str) {
		if(str == null) return "''";
		return "'" + convertQuote(str) + "'";
	}

	public static String  convertQuote(String str) {
		StringBuffer sb = new StringBuffer(str);
		for( int i = 0; i < sb.length(); i++) {
			if(sb.charAt(i) == '\'') {
				sb.insert( ++i, '\'');
			}
		}
		return sb.toString();
	}
}

