package pejb.ejb.session.board;
import javax.ejb.*;
import java.sql.*;
import java.rmi.*;
import pejb.ejb.base.*;
import pejb.beans.board.*;
import pejb.ejb.entity.board.*;

public class UpdateRecBean extends SessionAdapter {
	private Connection conn;
	private ResultSet rset;
	private Statement stmt;
	private EJBUtil util;
	private BoardHome board_home;
	String jndi_enc ="";
	
	///////// ejbCreate ///////////
	public void ejbCreate() {
		print("ejbCreate called");
	}
	//////// Business Methods ////////////////
	//ۼ
	public void updateRec(BoardRec record) throws RemoteException{
		try {
			Board ejb = board_home.findByPrimaryKey(new BoardPK(record.getRecno()));
			ejb.setUserName(record.getUserName());
			ejb.setEmail(record.getEmail());
			ejb.setSubject(record.getSubject());
			ejb.setContents(record.getContents());
			ejb.setPasswd(record.getPasswd());
		} catch(FinderException e) {
			print("couldn't find entity Board...");
			throw new RemoteException (e.getMessage());
		}
	}
	//ۻ
	public boolean deleteBoard(BoardRec record) throws RemoteException  {
		int replyCnt = record.getReplyCnt();
		int recno = record.getRecno();

		if(replyCnt == 0) {

			try {
				board_home.remove(new BoardPK(recno));
				updateReplyCnt(record.getDepth(), record.getRef(), record.getStep());
				return true;
			} catch(RemoveException e) {
				print("couldn't delete the record with primary Key" + recno);
			} catch(SQLException e) {
				print("couldn't successfully update the replycnt");
			}
		} 
		return false;
	}
	// or   ִ user  Ȯ
	public boolean isValidUser(int recno, String passwd) throws RemoteException{
		Board ejb = null;
		boolean isValidUser = false;
		try {
			ejb = board_home.findByPrimaryKey(new BoardPK(recno));
			if(ejb.getPasswd().equals(passwd))	isValidUser = true;
		} catch(FinderException e) {
			print("couldn't find the entity with " + recno);
		}
		return isValidUser;
	}
	
	
	///////// Overriden from SessionAdapter ////////////
	public void setSessionContext(SessionContext ctx ) throws RemoteException, EJBException {
		util = new EJBUtil();
		board_home = (BoardHome)util.lookup("java:comp/env/ejb/Board", BoardHome.class);
		this.jndi_enc = (String)util.getEnvEntry("ConnectionPool");
		this.ejb_name = getClass().getName();
		this.debug = true;
		super.setSessionContext(ctx);
	}
	public void ejbRemove() {
		print("ejbRemove called");
	}
	///////////// private Utilities //////////////////////
	//ۻ     ۵ 亯 (replyCnt) 
	private void updateReplyCnt(int depth, int ref, int step) throws SQLException {
		StringBuffer sb = new StringBuffer();
		PreparedStatement pstmt = null;
		sb.append("update board set replycnt = replycnt-1 where ref = ? and depth = ? and step = ");
		sb.append("(select max(step) from board where ref = ? and depth = ? and step < ? )");

		try {
			conn = util.getConnection(jndi_enc);
			pstmt = conn.prepareStatement(sb.toString());
			for(int i=depth-1; i>=0; i--) {
				pstmt.clearParameters();
				pstmt.setInt(1,ref);
				pstmt.setInt(2, i);
				pstmt.setInt(3, ref);
				pstmt.setInt(4, i);
				pstmt.setInt(5, step);
				pstmt.executeUpdate();
			}
		} finally {
			close(null, pstmt, conn);
		}				
		
	}	
	private void close(ResultSet rset, Statement stmt, Connection conn) {
		try {
			if(rset != null) rset.close();
			if(stmt != null) stmt.close();
			if(conn != null) {
				conn.close();
				conn = null;
			}
		} catch(Exception e) { e.printStackTrace(); }
	}	
}