package pejb.ejb.base;
import javax.rmi.PortableRemoteObject;
import javax.ejb.EJBException;
import javax.sql.DataSource;
import javax.naming.*;
import java.sql.*;
import java.util.*;

public class EJBUtil implements java.io.Serializable{
	private boolean debug = true;
	private Context ctx;
	private Properties p = new Properties();
	private String clsName = "";
	private String wlCtxFactory = "weblogic.jndi.WLInitialContextFactory";
	public static final int WEBLOGIC = 0;
	public static final int J2EESDK = 1;
	{
		p = new Properties();
		clsName = EJBUtil.class.getName();
	}
	public Object lookup(String jndiName, Class c, String user, String password, String url) {
		return lookup(jndiName, c, user, password, url, WEBLOGIC);
	}
	public Object lookup(String jndiName, Class c) {
		return lookup(jndiName, c, null, null, null);
	}
	public Object lookup(String jndiName, Class c, int serverType) {
		return lookup(jndiName, c, null, null, null, serverType);
	}
	public Connection getConnection(String jndiDB){
		try {
			
			InitialContext context = new InitialContext();
			DataSource ds = (DataSource)context.lookup(jndiDB);
			print("Got a valid DataSource Object");
			Connection conn = ds.getConnection();
			print("Got a valid connection from EJB Server");
			return conn;
		} catch(Exception e) {
			print("Couldn't get a valid DataSource or connection and throwing a EJBException");
			throw new EJBException (e);
		}
	}
	public Object getEnvEntry (String env) {
		String prefix = "";
		prefix = "java:comp/env/";
		try {
			InitialContext context = new InitialContext();
			Object entry = context.lookup(prefix + env);
			print("looked up " + entry);
			return entry;
		} catch(NamingException e) {
			print("JNDI ENC for given " + env + " not specified "); 
			e.printStackTrace();
			return env;
		}
	}
	
	public Object lookup(String jndiName, Class c, String user, String password, String url, int serverType) {
		if(url == null) url = "t3://localhost:7001";
		Object obj = null;
		if(this.ctx == null) {
			if (user != null && password != null) {
				p.put(Context.SECURITY_PRINCIPAL, user);
				p.put(Context.SECURITY_CREDENTIALS, password);
			}
			try {
				if(serverType == J2EESDK) {
					this.ctx = new InitialContext();
				} else if(serverType == WEBLOGIC) {
					p.put(Context.INITIAL_CONTEXT_FACTORY, wlCtxFactory);
					p.put(Context.PROVIDER_URL, url);
					print(clsName + " Initializing basic context factory properties for Weblogic");	
					this.ctx = new InitialContext(p);
				}
				print(" obtained a valid InitialContext Object");
			} catch(NamingException e) {
				print(" couldn't obtain a valid InitialContext Object");
				e.printStackTrace();
			}
				
		} // end of outer if clause
		try {
			obj = PortableRemoteObject.narrow(ctx.lookup(jndiName), c);
			print(" Looked up a valid EJBHome Object ==> " + c.getName());
		} catch(NamingException e) {
			e.printStackTrace();
		}
		return obj;
	}
	public Object narrow (Object remote_ref, Class c) {
		return PortableRemoteObject.narrow(remote_ref, c);
	}	
	private void print(String str) {
		if(debug) System.out.println("[" + clsName + "] " + str); 
	}
}
